{

=pod

=head1 NAME

SCNS.pm

=head1 SUMMARY

=head1 DESCRIPTION

=cut

package SCNS;
use strict;

use Carp;
use vars qw ($AUTOLOAD);

$SCNS::VERSION = 0.1;

sub new {
    my $pkg = shift;

    my $self = {};
    bless $self,$pkg;

    if (! $self->init(@_)) {
	return undef;
    }

    return $self;
}

sub init {
    my $self = shift;
    my $type = shift;

    $type =~ /^([^:]+):(.*)/;
    
    my $protocol = $1;
    my $uri      = $2;

    my $class = join("::",__PACKAGE__,uc $protocol);

    eval "require $class";
    if ($@) { carp $@; return undef; };

    $self->{"_handler"} = $class->new($uri);
    return 1;
}

sub DESTROY {
    my $self = shift;
    return 1;
}

sub AUTOLOAD {
    my $self = shift;
    
    $AUTOLOAD =~ /.*::(.*)$/;
    my $method = $1;

    return $self->{"_handler"}->$method(@_);
}

=pod

=head1 VERSION 

0.1

=head1 DATE

$Date: 2002/02/08 15:00:51 $

=head1 AUTHOR

Aaron Straup Cope

=head1 SEE ALSO

http://radio.userland.com/stories/storyReader$9889

=head1 TO DO

=over 4

=item

Finished installing (debugging) AUTOLOAD subs

=item

POD

=back

=head1 CHANGES

=head2 0.1

=over 4

=item

Initial revision

=back

=head1 LICENSE

Copyright (c) 2002 Aaron Straup Cope.

This is free software, you may use it and distribute it under the same terms as Perl itself.

=cut

return 1;

}
